Index: branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml
===================================================================
--- branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 3035)
+++ branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 3046)
@@ -129,4 +129,74 @@
 	<field id="ticemel_cea"  description="Rate of Melt at Upper Surface of Sea Ice (cell average)"      unit="kg/m2/s"  />
 
+
+        <!-- tidal composante -->
+        <field id="M2x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="M2y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="S2x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="S2y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="N2x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="N2y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="K1x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="K1y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="O1x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="O1y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="Q1x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="Q1y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="M4x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="M4y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="K2x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="K2y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="P1x"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="P1y"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="Mfx"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="Mfy"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+        <field id="Mmx"          description="M2 Elevation harmonic real part "                             unit="m"        />
+        <field id="Mmy"          description="M2 Elevation harmonic imaginary part"                         unit="m"        />
+
+        <field id="M2x_u"          description="M2 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="M2y_u"          description="M2 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="S2x_u"          description="S2 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="S2y_u"          description="S2 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="N2x_u"          description="N2 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="N2y_u"          description="N2 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="K1x_u"          description="K1 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="K1y_u"          description="K1 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="O1x_u"          description="O1 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="O1y_u"          description="O1 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Q1x_u"          description="Q1 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="Q1y_u"          description="Q1 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="M4x_u"          description="M4 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="M4y_u"          description="M4 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="K2x_u"          description="K2 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="K2y_u"          description="K2 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="P1x_u"          description="P1 current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="P1y_u"          description="P1 current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Mfx_u"          description="Mf current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="Mfy_u"          description="Mf current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Mmx_u"          description="Mm current barotrope along i-axis harmonic real part "      unit="m/s"        />
+        <field id="Mmy_u"          description="Mm current barotrope along i-axis harmonic imaginary part " unit="m/s"        />
+
+        <field id="M2x_v"          description="M2 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="M2y_v"          description="M2 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="S2x_v"          description="S2 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="S2y_v"          description="S2 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="N2x_v"          description="N2 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="N2y_v"          description="N2 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="K1x_v"          description="K1 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="K1y_v"          description="K1 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="O1x_v"          description="O1 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="O1y_v"          description="O1 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Q1x_v"          description="Q1 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="Q1y_v"          description="Q1 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="M4x_v"          description="M4 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="M4y_v"          description="M4 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="K2x_v"          description="K2 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="K2y_v"          description="K2 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="P1x_v"          description="P1 current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="P1y_v"          description="P1 current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Mfx_v"          description="Mf current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="Mfy_v"          description="Mf current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
+        <field id="Mmx_v"          description="Mm current barotrope along j-axis harmonic real part "      unit="m/s"        />
+        <field id="Mmy_v"          description="Mm current barotrope along j-axis harmonic imaginary part " unit="m/s"        />
       </group>
 
@@ -261,6 +331,11 @@
 	    <field ref="sst"    name="sst_1d_ave"                       />     <!-- mean -->
 	    <field ref="sst"    name="sst_1d_max"  operation="t_max(X)" />     <!-- max -->
+            <field ref="M2x"     name="M2_x_elev"  />
+            <field ref="M2y"     name="M2_y_elev"  />
 	  </file>
 	</group>
+
+
+
 
       </group>
Index: branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3035)
+++ branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3046)
@@ -863,2 +863,12 @@
     salfixmin = -9999      !  Minimum salinity after applying the increments
 /
+!-----------------------------------------------------------------------
+&nam_diaharm   !   Harmonic analysis of tidal constituents ('key_diaharm')
+!-----------------------------------------------------------------------
+    nit000_han=76           ! First time step used for harmonic analysis
+    nitend_han=5475         ! Last time step used for harmonic analysis
+    nstep_han=15            ! Time step frequency for harmonic analysis
+    nb_ana=2               ! Number of harmonics to analyse
+    tname(1)='M2'          ! Name of tidal constituents
+    tname(2)='K1'
+/