Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3054)
@@ -750,14 +750,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   jpnfl      = 1          !  total number of floats during the run
-   jpnnewflo  = 0          !  number of floats for the restart
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
-   ln_ariane  = .true.     !  Input with Ariane tool convention(T) 
-   ln_ascii   = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 3054)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_iomput
+ bld::tool::fppkeys key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_iomput key_mpp_mpi key_mpp_rep
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml	(revision 3054)
@@ -206,4 +206,16 @@
       </group>
 
+      <!-- variables available with key_float -->
+      <group id="floatvar" axis_ref="nfloat" grid_ref="scalarpoint" zoom_ref="1point">
+        <field id="traj_lon"   description="floats longitude"   unit="deg"  operation="inst(X)" />
+        <field id="traj_lat"   description="floats latitude"    unit="deg"   />
+        <field id="traj_dep"   description="floats depth"       unit="m"     />
+        <field id="traj_temp"  description="floats temperature" unit="degC"  />
+        <field id="traj_salt"  description="floats salinity"    unit="psu"   />
+        <field id="traj_dens"  description="floats density"     unit="kg/m3" />
+        <field id="traj_group" description="floats group"       unit="none"  />
+      </group>
+
+
       <!-- ptrc on T grid -->
 
@@ -325,5 +337,16 @@
           <field ref="aht2d_eiv"    name="soleaeiw" />
         </file>
-  
+ 
+       <!-- variables available with key_float, instantaneous fields -->
+        <file id="floats"  description="floats variables">
+            <field ref="traj_lon"   name="floats_longitude"   freq_op="432000" />
+            <field ref="traj_lat"   name="floats_latitude"    freq_op="432000" />
+            <field ref="traj_dep"   name="floats_depth"       freq_op="432000" />
+            <field ref="traj_temp"  name="floats_temperature" freq_op="432000" />
+            <field ref="traj_salt"  name="floats_salinity"    freq_op="432000" />
+            <field ref="traj_dens"  name="floats_density"     freq_op="432000" />
+            <field ref="traj_group" name="floats_group"       freq_op="432000" />
+        </file>
+
        <file id="5d_ptrc_T" name="auto" description="lobster sms variables" >
          <field ref="DET"      />
@@ -404,4 +427,5 @@
      <axis id="depthv" description="Vertical V levels" unit="m" positive=".false." />
      <axis id="depthw" description="Vertical W levels" unit="m" positive=".false." />
+     <axis id="nfloat" description="Number of float"   unit="no unit" positive=".false." />
      <axis id="none" description="axe non defini" unit="none" size="1" />
   </axis_definition> 
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3054)
@@ -755,10 +755,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3054)
@@ -750,14 +750,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   jpnfl      = 1          !  total number of floats during the run
-   jpnnewflo  = 0          !  number of floats for the restart
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
-   ln_ariane  = .true.     !  Input with Ariane tool convention(T)
-   ln_ascii   = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file 
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file 
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3054)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput 
+ bld::tool::fppkeys key_trabbl key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_floats key_mpp_rep
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 3054)
@@ -205,5 +205,16 @@
 	<field id="fram_trans" description="Sea Ice Mass Transport Through Fram Strait" unit="kg/s" />
       </group>
-         
+
+      <!-- variables available with key_float -->
+      <group id="floatvar" axis_ref="nfloat" grid_ref="scalarpoint" zoom_ref="1point">
+        <field id="traj_lon"   description="floats longitude"   unit="deg"  operation="inst(X)" />
+        <field id="traj_lat"   description="floats latitude"    unit="deg"   />
+        <field id="traj_dep"   description="floats depth"       unit="m"     />
+        <field id="traj_temp"  description="floats temperature" unit="degC"  />
+        <field id="traj_salt"  description="floats salinity"    unit="psu"   />
+        <field id="traj_dens"  description="floats density"     unit="kg/m3" />
+        <field id="traj_group" description="floats group"       unit="none"  />
+      </group>
+     
       <!-- ptrc on T grid -->
 
@@ -378,5 +389,6 @@
 	  <field ref="aht2d_eiv"    name="soleaeiw" />
 	</file>
-	
+
+
 	<file id="5d_icemod" name="auto" description="ice variables" >
 	  <field ref="ice_pres"                     />
@@ -394,4 +406,15 @@
 	  <field ref="snowpre"      name="isnowpre" />
 	</file>
+
+        <!-- variables available with key_float, instantaneous fields -->
+        <file id="floats"  description="floats variables">
+            <field ref="traj_lon"   name="floats_longitude"   freq_op="432000" />
+            <field ref="traj_lat"   name="floats_latitude"    freq_op="432000" />
+            <field ref="traj_dep"   name="floats_depth"       freq_op="432000" />
+            <field ref="traj_temp"  name="floats_temperature" freq_op="432000" />
+            <field ref="traj_salt"  name="floats_salinity"    freq_op="432000" />
+            <field ref="traj_dens"  name="floats_density"     freq_op="432000" />
+            <field ref="traj_group" name="floats_group"       freq_op="432000" />
+        </file>
 
        <file id="5d_diad_T" name="auto" description="additional pisces diagnostics" >
@@ -523,4 +546,5 @@
       <axis id="depthv" description="Vertical V levels" unit="m" positive=".false." />
       <axis id="depthw" description="Vertical W levels" unit="m" positive=".false." />
+      <axis id="nfloat" description="Number of float"   unit="no unit" positive=".false." />
       <axis id="none" description="axe non defini" unit="none" size="1" />
     </axis_definition> 
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3054)
@@ -764,15 +764,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   jpnfl      = 1          !  total number of floats during the run
-   jpnnewflo  = 0          !  number of floats for the restart
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
-                           !  or computed with Blanke' scheme (F)
-   ln_ariane  = .true.     !  Input with Ariane tool convention(T) 
-   ln_ascii   = .true.     !  Output with Ariane tool netcdf convention(T) or ascii file (F)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/iodef.xml
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/iodef.xml	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/iodef.xml	(revision 3054)
@@ -204,4 +204,15 @@
 	<field id="saltot"     description="global mean salinity"                       unit="psu"  />
 	<field id="fram_trans" description="Sea Ice Mass Transport Through Fram Strait" unit="kg/s" />
+      </group>
+
+      <!-- variables available with key_float -->
+      <group id="floatvar" axis_ref="nfloat" grid_ref="scalarpoint" zoom_ref="1point">
+        <field id="traj_lon"   description="floats longitude"   unit="deg"  operation="inst(X)" />
+        <field id="traj_lat"   description="floats latitude"    unit="deg"   />
+        <field id="traj_dep"   description="floats depth"       unit="m"     />
+        <field id="traj_temp"  description="floats temperature" unit="degC"  />
+        <field id="traj_salt"  description="floats salinity"    unit="psu"   />
+        <field id="traj_dens"  description="floats density"     unit="kg/m3" />
+        <field id="traj_group" description="floats group"       unit="none"  />
       </group>
 
@@ -263,4 +274,15 @@
     </file>
   
+    <!-- variables available with key_float, instantaneous fields -->
+    <file id="floats"  description="floats variables">
+         <field ref="traj_lon"   name="floats_longitude"   freq_op="432000" />
+         <field ref="traj_lat"   name="floats_latitude"    freq_op="432000" />
+         <field ref="traj_dep"   name="floats_depth"       freq_op="432000" />
+         <field ref="traj_temp"  name="floats_temperature" freq_op="432000" />
+         <field ref="traj_salt"  name="floats_salinity"    freq_op="432000" />
+         <field ref="traj_dens"  name="floats_density"     freq_op="432000" />
+         <field ref="traj_group" name="floats_group"       freq_op="432000" />
+     </file>
+ 
   </file_definition>
 
@@ -277,4 +299,5 @@
      <axis id="depthv" description="Vertical V levels" unit="m" positive=".false." />
      <axis id="depthw" description="Vertical W levels" unit="m" positive=".false." />
+     <axis id="nfloat" description="Number of float"   unit="no unit" positive=".false." />
      <axis id="none" description="axe non defini" unit="none" size="1" />
   </axis_definition> 
Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/namelist
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 3053)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 3054)
@@ -755,14 +755,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   jpnfl      = 1          !  total number of floats during the run
-   jpnnewflo  = 0          !  number of floats for the restart
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
-   ln_ariane  = .true.     !  Input with Ariane tool convention(T) 
-   ln_ascii   = .true.     !  Output with Ariane tool netcdf convention(T) or ascii file (F)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------