Index: branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3051)
+++ branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3055)
@@ -755,10 +755,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3051)
+++ branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3055)
@@ -772,14 +772,14 @@
 &namflo       !   float parameters                                      ("key_float")
 !-----------------------------------------------------------------------
-   jpnfl      = 1          !  total number of floats during the run
-   jpnnewflo  = 0          !  number of floats for the restart
-   ln_rstflo  = .false.    !  float restart (T) or not (F)
-   nn_writefl =      75    !  frequency of writing in float output file 
-   nn_stockfl =    5475    !  frequency of creation of the float restart file 
-   ln_argo    = .false.    !  Argo type floats (stay at the surface each 10 days)
-   ln_flork4  = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
-                           !  or computed with Blanke' scheme (F)
-   ln_ariane  = .true.     !  Input with Ariane tool convention(T)
-   ln_ascii   = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
+   jpnfl         = 1          !  total number of floats during the run
+   jpnnewflo     = 0          !  number of floats for the restart
+   ln_rstflo     = .false.    !  float restart (T) or not (F)
+   nn_writefl    =      75    !  frequency of writing in float output file 
+   nn_stockfl    =    5475    !  frequency of creation of the float restart file 
+   ln_argo       = .false.    !  Argo type floats (stay at the surface each 10 days)
+   ln_flork4     = .false.    !  trajectories computed with a 4th order Runge-Kutta (T)
+                              !  or computed with Blanke' scheme (F)
+   ln_ariane     = .true.     !  Input with Ariane tool convention(T)
+   ln_flo_ascii  = .true.     !  Output with Ariane tool netcdf convention(F) or ascii file (T)
 /
 !-----------------------------------------------------------------------
Index: branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm
===================================================================
--- branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3051)
+++ branches/2011/dev_MERCATOR_2011_MERGE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3055)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput 
+ bld::tool::fppkeys key_trabbl key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_floats key_mpp_rep