Index: branches/2011/dev_UKM0_2011/DOC/TexFiles/Biblio/Biblio.bib
===================================================================
--- branches/2011/dev_UKM0_2011/DOC/TexFiles/Biblio/Biblio.bib	(revision 3065)
+++ branches/2011/dev_UKM0_2011/DOC/TexFiles/Biblio/Biblio.bib	(revision 3066)
@@ -1306,4 +1306,12 @@
   volume = {23},
   pages = {2428--2446}
+}
+
+@ARTICLE{Hunke2008,
+  author = {E.C. Hunke and W.H. Lipscomb},
+  title = {CICE: the Los Alamos sea ice model documentation and software user's manual, 
+        Version 4.0},
+  publisher = {LA-CC-06-012, Los Alamos National Laboratory, N.M.},
+  year = {2008}
 }
 
Index: branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Chap_SBC.tex
===================================================================
--- branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3065)
+++ branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3066)
@@ -920,10 +920,36 @@
 ice-ocean fluxes, that are combined with the air-sea fluxes using the ice fraction of 
 each model cell to provide the surface ocean fluxes. Note that the activation of a 
-sea-ice model is is done by defining a CPP key (\key{lim2} or \key{lim3}). 
-The activation automatically ovewrite the read value of nn{\_}ice to its appropriate 
-value ($i.e.$ $2$ for LIM-2 and $3$ for LIM-3).
+sea-ice model is is done by defining a CPP key (\key{lim2}, \key{lim3} or \key{cice}). 
+The activation automatically overwrites the read value of nn{\_}ice to its appropriate 
+value ($i.e.$ $2$ for LIM-2, $3$ for LIM-3 or $4$ for CICE).
 \end{description}
 
 % {Description of Ice-ocean interface to be added here or in LIM 2 and 3 doc ?}
+
+\subsection   [Interface to CICE (\textit{sbcice\_cice})]
+			{Interface to CICE (\mdl{sbcice\_cice})}
+\label{SBC_cice}
+
+It is now possible to couple a global NEMO configuration (without AGRIF) to the CICE sea-ice
+model by using \key{cice}.  The CICE code can be obtained from 
+\href{http://oceans11.lanl.gov/trac/CICE/}{LANL} and the additional 'hadgem3' drivers will be required, 
+even with the latest code release.  Input grid files consistent with those used in NEMO will also be needed, 
+and CICE CPP keys \bf{ORCA_GRID}, \bf{CICE_IN_NEMO} and \bf{coupled} should be used (seek advice from UKMO 
+if necessary).  Currently the code is only designed to work when using the CORE forcing option for NEMO (with
+\textit{calc\_strair~=~true} and \textit{calc\_Tsfc~=~true} in the CICE name-list), or alternatively when NEMO 
+is coupled to the HadGAM3 atmosphere model (with \textit{calc\_strair~=~false} and \textit{calc\_Tsfc~=~false}).
+The code is intended to be used with \np{nn\_fsbc} set to 1 (although coupling ocean and ice less frequently 
+should work, it is possible the calculation of some of the ocean-ice fluxes needs to be modified slightly - the
+user should check that results are not significantly different to the standard case).
+
+There are two options for the technical coupling between NEMO and CICE.  The standard version allows
+complete flexibility for the domain decompositions in the individual models, but this is at the expense of global
+gather and scatter operations in the coupling which become very expensive on larger numbers of processors. The
+alternative option (using \key{nemocice_decomp} for both NEMO and CICE) ensures that the domain decomposition is
+identical in both models (provided domain parameters are set appropriately, and 
+\textit{processor\_shape~=~square-ice} and \textit{distribution\_wght~=~block} in the CICE name-list) and allows
+much more efficient direct coupling on individual processors.  This solution scales much better although it is at 
+the expense of having more idle CICE processors in areas where there is no sea ice.
+
 
 % -------------------------------------------------------------------------------------------------------------
Index: branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Introduction.tex
===================================================================
--- branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Introduction.tex	(revision 3065)
+++ branches/2011/dev_UKM0_2011/DOC/TexFiles/Chapters/Introduction.tex	(revision 3066)
@@ -63,4 +63,6 @@
 \citep{OASIS2006}. Two-way nesting is also available through an interface to the
 AGRIF package (Adaptative Grid Refinement in \textsc{Fortran}) \citep{Debreu_al_CG2008}.
+The interface code for coupling to an alternative sea ice model (CICE, \citet{Hunke2008}) is now 
+available although this is currently only designed for global domains, without the use of AGRIF.
 
 Other model characteristics are the lateral boundary conditions (chapter~\ref{LBC}).  