Index: branches/2011/dev_NOC_2011_MERGE/DOC/TexFiles/Chapters/Chap_ZDF.tex
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 2942)
+++ branches/2011/dev_NOC_2011_MERGE/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 3072)
@@ -1,4 +1,4 @@
 % ================================================================
-% Chapter Ñ Vertical Ocean Physics (ZDF)
+% Chapter  Vertical Ocean Physics (ZDF)
 % ================================================================
 \chapter{Vertical Ocean Physics (ZDF)}
@@ -539,5 +539,5 @@
 the clipping factor is of crucial importance for the entrainment depth predicted in 
 stably stratified situations, and that its value has to be chosen in accordance 
-with the algebraic model for the turbulent ßuxes. The clipping is only activated 
+with the algebraic model for the turbulent fluxes. The clipping is only activated 
 if \np{ln\_length\_lim}=true, and the $c_{lim}$ is set to the \np{rn\_clim\_galp} value.
 
@@ -981,8 +981,65 @@
 reduced as necessary to ensure stability; these changes are not reported.
 
+Limits on the bottom friction coefficient are not imposed if the user has elected to
+handle the bottom friction implicitly (see \S\ref{ZDF_bfr_imp}). The number of potential
+breaches of the explicit stability criterion are still reported for information purposes.
+
+% -------------------------------------------------------------------------------------------------------------
+%       Implicit Bottom Friction
+% -------------------------------------------------------------------------------------------------------------
+\subsection{Implicit Bottom Friction (\np{ln\_bfrimp}$=$\textit{T})}
+\label{ZDF_bfr_imp}
+
+An optional implicit form of bottom friction has been implemented to improve
+model stability. We recommend this option for shelf sea and coastal ocean applications, especially 
+for split-explicit time splitting. This option can be invoked by setting \np{ln\_bfrimp} 
+to \textit{true} in the \textit{nambfr} namelist. This option requires \np{ln\_zdfexp} to be \textit{false} 
+in the \textit{namzdf} namelist. 
+
+This implementation is realised in \mdl{dynzdf\_imp} and \mdl{dynspg\_ts}. In \mdl{dynzdf\_imp}, the 
+bottom boundary condition is implemented implicitly.
+
+\begin{equation} \label{Eq_dynzdf_bfr}
+\left.{\left( {\frac{A^{vm} }{e_3 }\ \frac{\partial \textbf{U}_h}{\partial k}} \right)} \right|_{mbk}
+	 = \binom{c_{b}^{u}u^{n+1}_{mbk}}{c_{b}^{v}v^{n+1}_{mbk}}
+\end{equation}
+
+where $mbk$ is the layer number of the bottom wet layer. superscript $n+1$ means the velocity used in the
+friction formula is to be calculated, so, it is implicit.
+
+If split-explicit time splitting is used, care must be taken to avoid the double counting of
+the bottom friction in the 2-D barotropic momentum equations. As NEMO only updates the barotropic 
+pressure gradient and Coriolis' forcing terms in the 2-D barotropic calculation, we need to remove
+the bottom friction induced by these two terms which has been included in the 3-D momentum trend 
+and update it with the latest value. On the other hand, the bottom friction contributed by the
+other terms (e.g. the advection term, viscosity term) has been included in the 3-D momentum equations
+and should not be added in the 2-D barotropic mode.
+
+The implementation of the implicit bottom friction in \mdl{dynspg\_ts} is done in two steps as the
+following:
+
+\begin{equation} \label{Eq_dynspg_ts_bfr1}
+\frac{\textbf{U}_{med}-\textbf{U}^{m-1}}{2\Delta t}=-g\nabla\eta-f\textbf{k}\times\textbf{U}^{m}+c_{b}
+\left(\textbf{U}_{med}-\textbf{U}^{m-1}\right)
+\end{equation}
+\begin{equation} \label{Eq_dynspg_ts_bfr2}
+\frac{\textbf{U}^{m+1}-\textbf{U}_{med}}{2\Delta t}=\textbf{T}+
+\left(g\nabla\eta^{'}+f\textbf{k}\times\textbf{U}^{'}\right)-
+2\Delta t_{bc}c_{b}\left(g\nabla\eta^{'}+f\textbf{k}\times\textbf{u}_{b}\right)
+\end{equation}
+
+where $\textbf{T}$ is the vertical integrated 3-D momentum trend. We assume the leap-frog time-stepping
+is used here. $\Delta t$ is the barotropic mode time step and $\Delta t_{bc}$ is the baroclinic mode time step.
+ $c_{b}$ is the friction coefficient. $\eta$ is the sea surface level calculated in the barotropic loops
+while $\eta^{'}$ is the sea surface level used in the 3-D baroclinic mode. $\textbf{u}_{b}$ is the bottom
+layer horizontal velocity.
+
+
+
+
 % -------------------------------------------------------------------------------------------------------------
 %       Bottom Friction with split-explicit time splitting
 % -------------------------------------------------------------------------------------------------------------
-\subsection{Bottom Friction with split-explicit time splitting}
+\subsection{Bottom Friction with split-explicit time splitting (\np{ln\_bfrimp}$=$\textit{F})}
 \label{ZDF_bfr_ts}
 
@@ -993,7 +1050,7 @@
 {\key{dynspg\_flt}). Extra attention is required, however, when using 
 split-explicit time stepping (\key{dynspg\_ts}). In this case the free surface 
-equation is solved with a small time step \np{nn\_baro}*\np{rn\_rdt}, while the three 
-dimensional prognostic variables are solved with a longer time step that is a 
-multiple of \np{rn\_rdt}. The trend in the barotropic momentum due to bottom 
+equation is solved with a small time step \np{rn\_rdt}/\np{nn\_baro}, while the three 
+dimensional prognostic variables are solved with the longer time step 
+of \np{rn\_rdt} seconds. The trend in the barotropic momentum due to bottom 
 friction appropriate to this method is that given by the selected parameterisation 
 ($i.e.$ linear or non-linear bottom friction) computed with the evolving velocities 
@@ -1018,11 +1075,14 @@
 \end{enumerate}
 
-Note that the use of an implicit formulation
+Note that the use of an implicit formulation within the barotropic loop
 for the bottom friction trend means that any limiting of the bottom friction coefficient 
 in \mdl{dynbfr} does not adversely affect the solution when using split-explicit time 
 splitting. This is because the major contribution to bottom friction is likely to come from 
-the barotropic component which uses the unrestricted value of the coefficient.
-
-The implicit formulation takes the form:
+the barotropic component which uses the unrestricted value of the coefficient. However, if the
+limiting is thought to be having a major effect (a more likely prospect in coastal and shelf seas
+applications) then the fully implicit form of the bottom friction should be used (see \S\ref{ZDF_bfr_imp} ) 
+which can be selected by setting \np{ln\_bfrimp} $=$ \textit{true}.
+
+Otherwise, the implicit formulation takes the form:
 \begin{equation} \label{Eq_zdfbfr_implicitts}
  \bar{U}^{t+ \rdt} = \; \left [ \bar{U}^{t-\rdt}\; + 2 \rdt\;RHS \right ] / \left [ 1 - 2 \rdt \;c_b^{u} / H_e \right ]  
@@ -1091,5 +1151,5 @@
 The essential goal of the parameterization is to represent the momentum 
 exchange between the barotropic tides and the unrepresented internal waves 
-induced by the tidal ßow over rough topography in a stratified ocean. 
+induced by the tidal flow over rough topography in a stratified ocean. 
 In the current version of \NEMO, the map is built from the output of 
 the barotropic global ocean tide model MOG2D-G \citep{Carrere_Lyard_GRL03}.